function [Ft Vt mappedX]=find_range_null(F,X,epsilon,FonX)

if length(F.nPerRank)<2
    FonX=repmat(F.rank{1},size(X,1),1);
    candidatesEvaluated = X; 
else
    if nargin==3
        FonX = out_of_sample_vca(X,F);
    end
    nBlow=F.nPerRank(2);
    nToBlow=F.nPerRank(end);
    candidatesEvaluated = blow_x(FonX,nBlow,nToBlow);
end

[C A] = pproject(FonX,candidatesEvaluated);  %Outputs the list of candidates projected on current features.
[U D]=svd(A');
if ~isvector(D)
    D=diag(D);
else
    D=D(1);
end
[D Dsorted]=sort(D,'descend');
if length(D)<size(U,2);
    Dsorted=[Dsorted; (length(D):size(U,2))'];
    D=[D;zeros(size(D,2)-length(D),1)];
end
U=U(:,Dsorted);
variableSet=D> epsilon;
g=C*U(:,variableSet); %Features with high variance
Vt=C*U(:,~variableSet); %Features with low variance.
newFeaturesEval=[FonX candidatesEvaluated]*g; %Evaluate data set on new selected features.
newFeatureNorm=sqrt(sum(newFeaturesEval.*newFeaturesEval,1));
newFeaturesNormalized=newFeaturesEval./repmat(newFeatureNorm,size(newFeaturesEval,1),1);
Ft=g./repmat(newFeatureNorm,size(g,1),1); %Normalize new features.
mappedX=[FonX newFeaturesNormalized];

function [p pX]=pproject(X,C)
%% Project set of candidates on space orthogonal to current space of features.
blownCandidatesProjected=X\C;
p= [-blownCandidatesProjected;eye(size(C,2))];
pX=C-X*blownCandidatesProjected;


