function mappedX=out_of_sample_vca(X,VF)
%OUT_OF_SAMPLE_VCA  Evaluates X on the polynomials in VF. 
%   mappedX = OUT_OF_SAMPLE_VCA(X,VF) Evaluates the data set X on the
%   polynomials in VF. VF is a struct of type V or of type F produced by
%   vca.
%
% This file can be obtained from http://www.cs.huji.ac.il/~rlivni73
% You are free to use, change, or redistribute this code in any way you
% want for non-commercial purposes.
%
% (C) Roi Livni, 2013
% Hebrew University of Jerusalem
% see also vca

%%
    if isempty(VF)
    mappedX=[];
    return
    end
if isfield(VF,'F')

F=VF.F;
rankMax=length(F.nPerRank);
mappedXF=[F.rank{1}*ones(size(X,1),1) [F.rank{1}*ones(size(X,1),1) X]*F.rank{2}];
mappedX=[[F.rank{1}*ones(size(X,1),1) X]*VF.rank{2}];
firstRankFeatures=F.nPerRank(2);
for iDeg=3:rankMax
    toBlow=F.nPerRank(iDeg-1);
    lastDegBlown=blow_x(mappedXF,firstRankFeatures,toBlow);
    mappedX=[mappedX [mappedXF lastDegBlown]*VF.rank{iDeg}];
    mappedXF=[mappedXF [mappedXF lastDegBlown]*F.rank{iDeg}];
end
else
    rankMax=length(VF.nPerRank);
    mappedX=[VF.rank{1}*ones(size(X,1),1) [VF.rank{1}*ones(size(X,1),1) X]*VF.rank{2}];
    firstRankFeatures=VF.nPerRank(2);
    for iDeg=3:rankMax
        toBlow=VF.nPerRank(iDeg-1);
        lastDegBlown=blow_x(mappedX,firstRankFeatures,toBlow);
        mappedX=[mappedX [mappedX lastDegBlown]*VF.rank{iDeg}];
    end
end